#include "catch.h"

#include "EdgeT.h"
#include "NodeT.h"

#include <cmath>

#define ADMISS_ERR 1e-20

bool approx(double a, double b) {
  return abs(a - b) < ADMISS_ERR;
}

TEST_CASE( "tests for EdgeT" , "[EdgeT]" ) {
  NodeT n1(0.0, 0.0, JUNCTION);
  NodeT n2(1.0, 1.0, JUNCTION);
  
  EdgeT e1(n1, n2);
  EdgeT e2(n1, n2);
  EdgeT e3(n2, n1);
  
  SECTION( "constructor for node 1" ){
    REQUIRE( n1.equal(e1.node1()) );
  }
  
  SECTION( "constructor for node 2" ){
    REQUIRE( n2.equal(e1.node2()) );
  }
  
  SECTION( "length" ){
    REQUIRE( approx(e1.length(), sqrt(2.0)) );
  }
}